#warning "zastapic 'xxx_veryfy' przez 'xxxxx' wczesniejsze 'xxxx' przemianowac z 'Read/Write' na 'rd/wr' "

//******************************************************************//
//																	//
//				(C) 2017 R-MIK Sawomir Skrzyski					//
//				slawomir.skrzynski@ep.com.pl						//
//																	//
//	Programu nie mona rozpowszechnia bez pisemnej zgody autora!	//
//																	//
//******************************************************************//


//#define	FT201WR		0x22 << 1
//#define	FT201RD		FT201WR|1


//=======================================================================//
byte StFT201=-1;
//0x00 Suspended
//0x01 Default
//0x02 Addressed
//0x03 Configured

byte IdFT201[3] = {-1, -1, -1};
//ID[0] - pewnie vid pid jeli rny od domylnego
//ID[1] -
//ID[2] - wartoc ustawiana w TF_PROG

word vidFT201, pidFT201;


extern void ReadIdFT201();
extern void ReadStFT201();
extern byte PutCharFT201( byte znak );
extern word GetFT201();
extern word ReadDataFT201();
extern byte AvailableFT201();
extern void PrintStringFT201();
extern void PrintStringFT201_P();
extern void FlushFT201();
word ReadMtpFT201( word adres, word len, byte *buf );
extern word ReadMtpFT201_verify( word adres, word len, byte *buf, byte repeat );
word RdMtpFT201( word adres );
byte WriteMtpFT201( word adres, byte data );
extern byte WriteMtpFT201_verify( word adres, byte data, byte repeat );
extern byte SetMtpAdrFT201( word adres );


//======================================================================//
byte PutCharFT201( byte znak )
{
byte st;



	//----- START -----//
	st = TWI_Start(); if ( st != 8 && st != 0x10 ) return( false );
//str.27	"AN_255_USB to I2C Example using the FT232H and FT201X devices"
	st = TWI_Write( FT201WR );	if ( st != 0x18 ){ TWI_Exit(); return( false ); }	// Brak ACK to bufor nadawczy peny
	st = TWI_Write( znak );	if ( st != 0x28 ){ TWI_Exit(); return( false ); }
	//----- STOP -----//
	st = TWI_Stop();


	return( true );
}


//-----------------------------------------------------------------
void PrintStringFT201(char *text)
{
char znak;


	while (*text)					// Wyswietl tekst z RAMu
  	 	{
		znak = (*text);
		PutCharFT201( znak );
   		text++;
		}
}



//-----------------------------------------------------------------
void PrintStringFT201_P(char *text)
{
char znak,x;


	for (x=0; x<250; x++)			// Wyswietl tekst z FLASH-a
  	 	{
		znak = pgm_read_byte(text);
		if ( znak == 0 ) break;
		PutCharFT201( znak );
   		text++;
		}
}


//------------------------------------------------------------------
word GetFT201()
{
//	if ( !AvailableFT201() ) return( NONE );
	return( ReadDataFT201() );
}


//------------------------------------------------------------------
word ReadDataFT201()
{
byte st, dana=NONE;



	//----- START -----//
	st = TWI_Start(); if ( st != 8 && st != 0x10 ) return( NONE );
	st = TWI_Write( FT201RD );
		if ( st == 0x48 ){ TWI_Exit(); return( NONE ); }	// Brak ACK oznacza brak znaku do odbioru
		if ( st != 0x40 ){ TWI_Exit(); return( NONE ); }
	// Odczytaj ostatni bajt
	dana = TWI_Read( false ); if ( TWI_Status != 0x58  ){ TWI_Exit(); return( NONE ); }
	//----- STOP -----//
	st = TWI_Stop();


	return( dana );
}


//------------------------------------------------------------------
byte AvailableFT201()
{
byte st, ava, repeat=3;


	do
	{
	//----- START -----//
	st = TWI_Start(); if ( st != 8 && st != 0x10 ) continue;
	// General adres
	st = TWI_Write( 0 );	if ( st != 0x18 ){ TWI_Exit(); continue; }
//str.25	"AN_255_USB to I2C Example using the FT232H and FT201X devices"
	//DataAvailable command
	st = TWI_Write( 0x0C );	if ( st != 0x28 ){ TWI_Exit(); continue; }
	//----- START -----//
	st = TWI_Start(); if ( st != 8 && st != 0x10 ) return( 0 );
	st = TWI_Write( FT201RD );	if ( st != 0x40 ){ TWI_Exit(); continue; }
	// Odczytaj ostatni bajt
	ava = TWI_Read( false ); if ( TWI_Status != 0x58  ){ TWI_Exit(); continue; }
	//----- STOP -----//
	st = TWI_Stop();
	return( ava );
	}while( repeat-- );

	return 0;
}


//----------------------- czytaj ID ----------------------------
void ReadIdFT201()
{
byte st;


	//----- START -----//
	st = TWI_Start(); if ( st != 8 && st != 0x10 ) return;
//str.22	"AN_255_USB to I2C Example using the FT232H and FT201X devices"
	//cmd read ID
	st = TWI_Write( 0xF8/*0x7C*/ );	if ( st != 0x18 ){ TWI_Exit(); return; }
	st = TWI_Write( FT201RD );	if ( st != 0x28 ){ TWI_Exit(); return; }

	//----- START -----//
	st = TWI_Start(); if ( st != 8 && st != 0x10 ) return( st );
	//ID command 0x7C
	st = TWI_Write( 0xF9/*0x7c*/ );	if ( st != 0x40 ){ TWI_Exit(); return; }
	IdFT201[0] = TWI_Read( true ); if ( TWI_Status != 0x50  ){ TWI_Exit(); return; }
	IdFT201[1] = TWI_Read( true ); if ( TWI_Status != 0x50  ){ TWI_Exit(); return; }
	// Odczytaj ostatni bajt
	IdFT201[2] = TWI_Read( false ); if ( TWI_Status != 0x58  ){ TWI_Exit(); return; }
//ID[0] - pewnie vid pid jeli rny od domylnego
//ID[1] -
//ID[2] - wartoc ustawiana w TF_PROG
	//----- STOP -----//
	st = TWI_Stop();
}


//-------------------- czytaj status --------------------------------
void ReadStFT201()
{
byte st, repeat=3;


	do
	{
	//----- START -----//
	st = TWI_Start(); if ( st != 8 && st != 0x10 ) continue;
	// General adres
	st = TWI_Write( 0 );	if ( st != 0x18 ){ TWI_Exit(); continue; }
//str.22	"AN_255_USB to I2C Example using the FT232H and FT201X devices"
	//cmd status
	st = TWI_Write( 0x16 );	if ( st != 0x28 ){ TWI_Exit(); continue; }
	//----- START -----//
	st = TWI_Start(); if ( st != 8 && st != 0x10 ) continue;

	st = TWI_Write( FT201RD );	if ( st != 0x40 ){ TWI_Exit(); continue; }
	// Odczytaj ostatni bajt
	StFT201 = TWI_Read( false ); if ( TWI_Status != 0x58  ){ TWI_Exit(); continue; }
//0x00 Suspended
//0x01 Default
//0x02 Addressed
//0x03 Configured
	//----- STOP -----//
	st = TWI_Stop();
	}while( repeat-- );
}


//------------------------------------------------------------------
void FlushFT201()
{
byte st, repeat=3;


	do
	{
	//----- START -----//
	st = TWI_Start(); if ( st != 8 && st != 0x10 ) continue;
	// General adres
	st = TWI_Write( 0 );	if ( st != 0x18 ){ TWI_Exit(); continue; }
	// $20 - nie byo ACK
	// $38 - przegrany arbritarz
	// CMD flush
	st = TWI_Write( 0x0E );	if ( st != 0x28 ){ TWI_Exit(); continue; }
	//----- STOP -----//
	st = TWI_Stop();
	}while( repeat-- );
}


//------------------------------------------------------------------
word ReadMtpFT201( word adres, word len, byte *buf )
{
word x, d;


	for(x=0; x<len; x++)
		{
		*buf++ = d = RdMtpFT201(adres+x);
		if( d==NONE ) return( x );
		}

	return( x );
}


//------------------------------------------------------------------
word ReadMtpFT201_verify( word adres, word len, byte *buf, byte repeat )
{
word x, d;


	for(x=0; x<len; x++)
		{
		do
			{
			d = RdMtpFT201(adres+x);
			if ( RdMtpFT201(adres+x)==d ){ *buf = d; break; }
// if ( !repeat-- ) return( x );
			}while( repeat-- );
		buf++;
		}

	return( x );
}


//------------------------------------------------------------------
word RdMtpFT201( word adres )
{
byte st, dat, repeat=3;


	do
		{
		if ( !SetMtpAdrFT201( adres )) continue;

		//----- START -----//
		st = TWI_Start(); if ( st != 8 && st != 0x10 ) continue;
		// General adres
		st = TWI_Write( 0 ); if ( st != 0x18 ){ TWI_Exit(); continue; }
		// CMD RD mem
		st = TWI_Write( 0x14 );	if ( st != 0x28 ){ TWI_Exit(); continue; }

		//----- START -----//
		st = TWI_Start(); if ( st != 8 && st != 0x10 ) continue;
		// Slave adres RD
		st = TWI_Write( FT201RD );	if ( st != 0x40 ){ TWI_Exit(); continue; }

		// Odczytaj ostatni bajt
		dat = TWI_Read( false ); if ( TWI_Status != 0x58  ){ TWI_Exit(); continue; }

		return( dat );
		}while( repeat-- );
	//----- STOP -----//
	st = TWI_Stop();

	return( NONE );
}


//------------------------------------------------------------------
byte SetMtpAdrFT201( word adres )
{
byte st, repeat=3;


	do
	{
	//----- START -----//
	st = TWI_Start(); if ( st != 8 && st != 0x10 ) continue;
	// General adres
	st = TWI_Write( 0 );	if ( st != 0x18 ){ TWI_Exit(); continue; }
	// $20 - nie byo ACK
	// $38 - przegrany arbritarz
	// CMD adres MTP
	st = TWI_Write( 0x10 );	if ( st != 0x28 ){ TWI_Exit(); continue; }

	//----- START -----//
	st = TWI_Start(); if ( st != 8 && st != 0x10 ) continue;
	// Slave adres WR
	st = TWI_Write( FT201WR );	if ( st != 0x18 ){ TWI_Exit(); continue; }
	// MSB
	st = TWI_Write( adres>>8 );	if ( st != 0x28 ){ TWI_Exit(); continue; }
	// LSB
	st = TWI_Write( adres );	if ( st != 0x28 ){ TWI_Exit(); continue; }

	//----- STOP -----//
	st = TWI_Stop();
	return true;
	}while( repeat-- );


	return( false );
}


//------------------------------------------------------------------
byte WriteMtpFT201_verify( word adres, byte data, byte repeat )
{
byte rd;


	ReadMtpFT201( adres, 1, &rd );		// Odczytaj
	if ( rd==data ) return( true );		// Takie same to wyjd


	do
	{
	if( WriteMtpFT201( adres, data ) )		// Jeli FT201 przyj dana do zapisu
		{
		_delay_ms(10);						// Czekaj na zapis eeprom
		ReadMtpFT201( adres, 1, &rd );		// Odczytaj
		if ( rd==data ) return( true );
		}
	}while( repeat-- );


	return( false );
}


//------------------------------------------------------------------
byte WriteMtpFT201( word adres, byte data )
{
byte st, repeat=3;


	do
	{
		if ( !SetMtpAdrFT201( adres ) ) continue;
		//----- START -----//
		st = TWI_Start(); if ( st != 8 && st != 0x10 ) continue;
		// General adres
		st = TWI_Write( 0 ); if ( st != 0x18 ){ TWI_Exit(); continue; }
		// CMD WR mem
		st = TWI_Write( 0x12 );	if ( st != 0x28 ){ TWI_Exit(); continue; }

		//----- START -----//
		st = TWI_Start(); if ( st != 8 && st != 0x10 ) continue;
		// Slave adres WR
		st = TWI_Write( FT201WR );	if ( st != 0x18 ){ TWI_Exit(); continue; }

		st = TWI_Write( data );	if ( st != 0x28 ){ TWI_Exit(); continue; }

		//----- STOP -----//
//	st = TWI_Stop();
		return( true );
	}while( repeat-- );


	return( false );
}


//=======================================================================//
