

//******************************************************************//
//																	//
//				(C) 2017 R-MIK Sawomir Skrzyski					//
//				slawomir.skrzynski@ep.com.pl						//
//																	//
//	Programu nie mona rozpowszechnia bez pisemnej zgody autora!	//
//																	//
//******************************************************************//


//#define	RD_FT220()		(PINE & _BV(PE7))	// Wejcie statusu
//#define	PORT_FT220()	PORTE |= _BV(PE7)	// Wejcie podcignite


//=======================================================================//
byte StFT220;
//0x00 Suspended
//0x01 Default
//0x02 Addressed
//0x03 Configured

word vidFT220, pidFT220;


extern byte	InitFT220();
extern byte ReadModemFT220();
extern byte SetModemFT220( byte modem );
extern byte PutCharFT220( byte znak );
extern byte FlushFT220();
extern word GetFT220();
extern byte PrintStringFT220( byte *text );
extern byte PrintStringFT220_P( byte *text );
extern byte SetMtpAdrFT220( word adres );
extern word ReadMtpFT220( word adres, word len, byte *buf );
extern byte WriteMtpFT220( word adres, byte data );


//=======================================================================//
						// Kodowanie CMD w trybie SPI 1-bit:
						// Bit	7		6	5	4		3	2		1		0
						//  	CMD3	x	x	CMD2	x	CMD1	CMD0	x
						//	  3xx2x10x
#define	cmdFT220_WrChar		0b00000001 		// Write request command (CMD=0x00)
#define	cmdFT220_GetChar	0b00000011		// Read request command (CMD=0x01 0x0001)
#define	cmdFT220_StModem	0b00000101		// Read modem status (CMD=0x02 0b0010)
#define	cmdFT220_WrModem	0b00000111 		// write modem status (CMD=0x03 0x0011)
#define	cmdFT220_Flush		0b00010001		// write buffer flush (CMD=0x04 0x0100)
#define	cmdFT220_AdrMtp		0b00010011		// Adres MTP memory (CMD=0x05 0b0101)
#define	cmdFT220_WriteMTP	0b00010101		// write eeprom (CMD=0x06 0b0110)
#define	cmdFT220_ReadMTP	0b00010111		// READ MTP memory (CMD=0x07 0b0111)
#define	cmdFT220_RDstatus	0b10000001		// 0x08


//=======================================================================//
byte InitFT220()
{
	PORT_FT220();						// Wejcie podcignite


	SPI_SSl();
	SpiWrite( cmdFT220_RDstatus );		// Read USB Status (CMD=0x08 0b1000)
	StFT220 = SpiRead();
	SPI_SSh();


	ReadMtpFT220( 2, 2, &vidFT220 );
	ReadMtpFT220( 4, 2, &pidFT220 );


	return( StFT220 );
}


//----------------------------------------------------------------------//
byte SetMtpAdrFT220( word adres )
{
byte st;


	SPI_SSl();
	SpiWrite( cmdFT220_AdrMtp );	// Adres MTP memory (CMD=0x05 0b0101)
	st = RD_FT220();
	if ( st ){ SPI_SSh(); return( false ); }
	SpiWrite( adres>>8 );			// MSB
	SpiWrite( adres );				// LSB
	SPI_SSh();


	return( true );
}


//----------------------------------------------------------------------//
//	Zwraca liczbe odczytanych danych
//----------------------------------------------------------------------//
word ReadMtpFT220( word adres, word len, byte *buf )
{
word x;
byte st, y;


	for(word x=0; x<256; x++)
		{
		SetMtpAdrFT220( adres+x );
		SetMtpAdrFT220( adres+x );
//		if ( !st ){ SPI_SSh(); return( x ); }

		// Pierwszy odczyt olewamy
		SPI_SSl();
		SpiWrite( cmdFT220_ReadMTP );			// READ MTP memory (CMD=0x07 0b0111)
//st = RD_FT220();
//	*buf = SpiRead();
		SPI_SSh();

		// Czytamy max 10 razy
		for(byte y=0; y<10; y++)
			{
			SPI_SSl();
			SpiWrite( cmdFT220_ReadMTP );		// READ MTP memory (CMD=0x07 0b0111)
			st = RD_FT220();
			*buf = SpiRead();
			SPI_SSh();
			if ( !st ) break;
			}
		if ( y>=9 ) return( x );
		buf++;
		}


	return( x );
}


//----------------------------------------------------------------------//
byte WriteMtpFT220( word adres, byte data )
{
byte st;


	SetMtpAdrFT220( adres );
	SetMtpAdrFT220( adres );

	SPI_SSl();
	SpiWrite( cmdFT220_WriteMTP );		// write eeprom (CMD=0x06 0b0110)
	st = RD_FT220();
	SpiWrite( data );
	SPI_SSh();
	_delay_ms(10);


	return( st );
}


//----------------------------------------------------------------------//
byte PrintStringFT220( byte *text )
{
char znak, st;


	SPI_SSl();
//todo: po uaktywnieniu linii SS na linii MOSI pojawia sie informacja o przepenieniu bufora TX
	SpiWrite( cmdFT220_WrChar );// Write request command (CMD=0x00)
	st = RD_FT220();
	if ( st ){ SPI_SSh(); return( false ); }
	while (*text)					// Wyswietl tekst z RAMu
  	 	{
		znak = (*text);
		SpiWrite( znak );
   		text++;
		}
	SPI_SSh();


	return( true );
}


//----------------------------------------------------------------------//
byte PrintStringFT220_P( byte *text )
{
char znak, x, st;


	SPI_SSl();
//todo: po uaktywnieniu linii SS na linii MOSI pojawia sie informacja o przepenieniu bufora TX
	SpiWrite( cmdFT220_WrChar );// Write request command (CMD=0x00)
	st = RD_FT220();
	if ( st ){ SPI_SSh(); return( false ); }
	for (x=0; x<250; x++)			// Wyswietl tekst z FLASH-a
  	 	{
		znak = pgm_read_byte(text);
		if ( znak == 0 ) break;
		SpiWrite( znak );
   		text++;
		}
	SPI_SSh();


	return( true );
}


//----------------------------------------------------------------------//
word GetFT220()
{
byte znak, st;


	SPI_SSl();
	SpiWrite( cmdFT220_GetChar );		// Read request command (CMD=0x01 0x0001)
	if ( (st=RD_FT220()) )
		{
		SPI_SSh();
		return( NONE );
		}
	znak = SpiRead();
	SPI_SSh();


	return( znak );
}


//----------------------------------------------------------------------//
byte FlushFT220()
{
	byte st;


#warning "USER: cis nie czysci choc CMD jest potwierxszona"
	SPI_SSl();
	SpiWrite( cmdFT220_Flush );		// write buffer flush (CMD=0x04 0x0100)
	st = RD_FT220();
	SPI_SSh();


	return( st );
}


//----------------------------------------------------------------------//
byte ReadModemFT220()
{
byte st=-1;


	SPI_SSl();
	SpiWrite( cmdFT220_StModem );		// Read modem status (CMD=0x02 0b0010)
	st = SpiRead();						// 01 - DTR, 02-RTS
	SPI_SSh();


	return( st );
}


//----------------------------------------------------------------------//
//	Bit-1 OFF, 0-ON
//	bit	7	CD
//	bit 6	RI
//	bit 5	DSR
//	bit 4	CTS
//----------------------------------------------------------------------//
byte SetModemFT220( byte modem )
{
byte st;


	SPI_SSl();
	SpiWrite( cmdFT220_WrModem );
	st = RD_FT220();
	SpiWrite( modem );
	SPI_SSh();


	return( st );
}


//----------------------------------------------------------------------//
byte PutCharFT220( byte znak )
{
	byte st;


	SPI_SSl();
//todo: po uaktywnieniu linii SS na linii MOSI pojawia sie informacja o przepenieniu bufora TX
	SpiWrite( cmdFT220_WrChar );		// Write request command (CMD=0x00)
	st = RD_FT220();
	SpiWrite( znak );
	SPI_SSh();


	return( st );
}





//=======================================================================//




